-------------------------------------------------------------------------------
-- Title				:	Full Adder	
-- Project			:	Sample code
-- File				:	full_adder.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	data flow model of full adder
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity full_adder is
     
	 Port (
	 		 a 		: in std_logic;
           	 b 		: in std_logic;
             cin 	: in std_logic;
             sum    : out std_logic;
             cout 	: out std_logic
		   );

end full_adder;

architecture Behavioral of full_adder is

begin

-- sum o/p	
sum		<=		a xor b xor cin;

-- carry o/p
cout	<=		((a and b) or (b and cin)or (a and cin)); 	


end Behavioral;
