-------------------------------------------------------------------------------
-- Title				:	Structural Full Adder
-- Project			:	Sample code
-- File				:	fu_add_str.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Interface		:	
-- Components		:	half adder
-------------------------------------------------------------------------------
-- Description		:	Full adder using two Half adders
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity fu_add_str is
    
	Port 
	   (		a_in 			: in std_logic;
            b_in 			: in std_logic;
           	carry_in 	: in std_logic;
           	sum_out 		: out std_logic;
           	carry_out 	: out std_logic
		);

end fu_add_str;

architecture Behavioral of fu_add_str is

component half_adder

port
	(		a,b			:	in	std_logic;
			sum,carry   :	out std_logic
    );

end component;

signal sum1,carry1,carry2	:	std_logic;

begin

-- port mapping of half adders
	ha0	:	half_adder port map (a_in,b_in,sum1,carry1);
	ha1	:	half_adder port map (sum1,carry_in,sum_out,carry2);
	carry_out	<=	carry1 or carry2;

end Behavioral;
