--------------------------------------------------------------------------------
-- Title				:	Toggle F/F with enable
-- Project			:	Sample code
-- File				:	T_FF.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	A T F/F with enable
--						USDP has Active 'LOW' Reset
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity T_FF is
    Port ( Clk 	: in std_logic;
           en,rst : in std_logic;
           t 		: out std_logic);
end T_FF;

architecture Behavioral of T_FF is
signal t_s	: std_logic;
begin

process(clk,rst)
begin
	if rst='0' then
		t_s	<= '0';
	elsif clk'event and clk='1' then
		if en='1' then
			t_s	<= not t_s;
		end if;
	end if;
end process;

t	<= t_s;


end Behavioral;
