--------------------------------------------------------------------------------
-- Title				:	Johnson counter with Enable
-- Project			:	Sample code
-- File				:	john_cntr.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	8-bit Johnson counter with enable.
--						USDP has Active 'LOW' Reset
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity john_cntr is
    Port ( clk 	: in std_logic;
           rst 	: in std_logic;
           en 		: in std_logic;
           q 		: out std_logic_vector(7 downto 0));
end john_cntr;

architecture Behavioral of john_cntr is
signal q_s	: std_logic_vector(7 downto 0);
begin

process(clk,rst)
begin
	if rst='0' then
		q_s	<=(others=>'0');
	elsif clk'event and clk='1' then
		if en='1' then
			q_s	<= not q_s(0) & q_s(7 downto 1);
		end if;
	end if;
end process;


q	<= q_s;

end Behavioral;
